<% 
 java.util.List<com.hello2morrow.sonargraph.core.model.element.Issue> unresolvedIssues = report.unresolvedIssues;
 java.util.List<com.hello2morrow.sonargraph.core.model.element.Resolution> resolutions = report.resolutions;
 java.util.Map<com.hello2morrow.sonargraph.core.model.analysis.IMetricLevel, 
 java.util.Map<com.hello2morrow.sonargraph.core.model.analysis.IMetricCategory, 
 java.util.Map<com.hello2morrow.sonargraph.core.model.analysis.IMetricDescriptor, 
 java.util.Set<com.hello2morrow.sonargraph.core.model.report.Report.MetricRow>>>> metricValueRows = report.getElementMetricsForPrint();
 
 boolean isScriptRunnerEnabled = report.getAvailableFeatures().contains(com.hello2morrow.sonargraph.core.model.common.SonargraphFeature.SCRIPTS_AUTOMATED);
 boolean isDuplicateCodeEnabled = report.getAvailableFeatures().contains(com.hello2morrow.sonargraph.core.model.common.SonargraphFeature.DUPLICATE_CODE);
 boolean isArchitectureCheckEnabled = report.getAvailableFeatures().contains(com.hello2morrow.sonargraph.core.model.common.SonargraphFeature.ARCHITECTURE)
 boolean isVirtualModelsEnabled = report.getAvailableFeatures().contains(com.hello2morrow.sonargraph.core.model.common.SonargraphFeature.VIRTUAL_MODELS);
%>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"/>
        <style type="text/css" MEDIA="all">@import url("hello2morrow.css");</style>
        <title>Sonargraph Architect Report</title>
    </head>

    <body>
        <a name="top"></a>
        <table width="100%" border="0" cellspacing="0" cellpadding="0">
            <tr>
                <td width="200" bgcolor="#333333"><img src="spacer.gif" alt="" width="200" height="65" border="0"></td>
                <td width="23" bgcolor="E3E4E5"><img src="spacer.gif" width="23" height="1"></td>
                <td width="100%" bgcolor="E3E4E5">
                    <table border="0" cellspacing="0" cellpadding="0">
                        <tr>
                            <td width="7" bgcolor="e3e4e5"><img src="spacer.gif" width="7" height="1"></td>
                            <td><img src="hello2morrow.gif" alt="hello2morrow" width="227" height="23" border="0"></td>
                            <td width="100%" align="right" bgcolor="e3e4e5"><img src="header.gif" alt="hello2morrow" width="543" height="65" border="0"></td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td colspan="3" bgcolor="#000000"></td>
            </tr>
            <tr>
<!-- start of navigation -->            
                <td bgcolor="#A7A9AC" valign="top">
                    <div class="leftNav">
                        <ul>
                            <li><a href="#system">System</a></li>
                            <li><a href="#automatedScripts">Automated Scripts <% 
                            if (isScriptRunnerEnabled) 
                            { 
                                out.println("(" + report.getAutomatedScriptConfigurations().size() + ")")
                            }%></a></li>
                            <li><a href="#workspace">Workspace</a></li>
                            <li><a href="#openIssues">Unresolved Issues (<%= unresolvedIssues.size() %>)</a></li>
                            <li><a href="#cycleGroups">Cycle Groups (<%= report.getNumberOfUnresolvedCycleGroups() %>)</a></li>
                            <li><a href="#duplicateBlocks">Duplicate Blocks <% 
                            if (isDuplicateCodeEnabled) 
                            { 
                                out.println("(" + report.getUnresolvedDuplicateIssues().size() + ")")
                            }%></a></li>
                            <li><a href="#resolutions">Resolutions <% 
                            if (isVirtualModelsEnabled) 
                            { 
                                out.println("(" + resolutions.size() + ")")
                            }%></a></li>
                            <li><a href="#elementMetrics">Element Level Metrics</a>
                                <ul>
                                    <% for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.analysis.IMetricLevel, java.util.Map<
                                               com.hello2morrow.sonargraph.core.model.analysis.IMetricCategory, 
                                                java.util.Map<com.hello2morrow.sonargraph.core.model.analysis.IMetricDescriptor, 
                                                java.util.Set<com.hello2morrow.sonargraph.core.model.report.Report.MetricRow>>>> entry : metricValueRows.entrySet())
                                    {
                                    %>
                                    <li><a class="secondLevel" href="#elementMetrics_<%=entry.getKey().getStandardName()%>"><%=entry.getKey().getPresentationName()%> Level Metrics</a></li>
                                    <%
                                    }
                                    %>
                                </ul>
                            </li>
                            <li><a href="#metricInfos">Metric Infos</a></li>
                        </ul>
                    </div>
                </td>
<!-- end of navigation -->
                <!-- start of spacer -->
                <td width="23"><img src="spacer.gif" width="23" height="1"></td><!-- end of spacer -->
                
                <!-- real content -->
                <td width="100%">
                    <table width="100%" border="0">
                        <tr>
                            <td width="1%" height="80" valign="center">
                                <image src="logo.gif" width="350"></image>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <h1><a name="system"></a>System: <%= report.softwareSystem.name %></h1>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <strong>Path: </strong><%= report.systemDirectoryPath %><br/>
                                <strong>System Description:<%= report.softwareSystem.description %></strong><br/>
                                <strong>Sonargraph Version: </strong><%= report.version %><br/>
                                <strong>Report Creation: </strong><%= report.timestampString %><br/>
                                <strong>Current Virtual Model: </strong><%= report.currentVirtualModel %> <br/>
                                <%
                                    if (report.getActiveProfile() != null && report.getActiveProfile().length() > 0)
                                    {
                                %>
                                        <strong>Workspace Profile: </strong><%= report.activeProfile %> <br/>
                                <%
                                    }
                                %>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <h2>Licensed Features</h2>
                                <table class="techTable">
                                    <tr>
                                        <th width="450">Feature</th>
                                    </tr>
                                    <% 
                                      int i = 0;
                                      for (com.hello2morrow.sonargraph.core.model.common.SonargraphFeature feature : report.getAvailableFeatures())
                                      {
                                        if (i % 2 == 0)
                                        {
                                            out.println("<tr class=\"a\">");
                                        }
                                        else 
                                        {
                                            out.println("<tr class=\"b\">");
                                        }
                                        i++;
                                        out.println("<td>");
                                        out.println(feature.getPresentationName());
                                        out.println("</td>");
                                        out.println("</tr>");
                                      }
                                    %>
                                </table>
                            </td>
                        </tr>
                        <% 
                        if(report.getUnavailableFeatures().size() > 0)
                        { 
                        %> 
                        <tr>
                            <td>
                                <h2>Not Licensed Features</h2>
                                <table class="techTable">
                                    <tr>
                                        <th width="450">Feature</th>
                                    </tr>
                                    <% 
                                      i = 0;
                                      for (com.hello2morrow.sonargraph.core.model.common.SonargraphFeature feature : report.getUnavailableFeatures())
                                      {
                                        if (i % 2 == 0)
                                        {
                                            out.println("<tr class=\"a\">");
                                        }
                                        else 
                                        {
                                            out.println("<tr class=\"b\">");
                                        }
                                        i++;
                                        out.println("<td>");
                                        out.println(feature.getPresentationName());
                                        out.println("</td>");
                                        out.println("</tr>");
                                      }
                                    %>
                                </table>    
                            </td>
                        </tr>
                        <%
                        }
                        %>
<!-- System Metrics -->                        
                        <tr class="a">
                            <td><h2>System Metrics</h2></td>
                        </tr>
                        <% for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.analysis.IMetricCategory, java.util.Map<com.hello2morrow.sonargraph.core.model.analysis.IMetricDescriptor, com.hello2morrow.sonargraph.core.model.analysis.IMetricValue>> nextCategory : report.getSystemLevelMetrics())
                        {
                        %>
                        <tr>
                            <td><strong>Metric Category: <%= nextCategory.getKey().getPresentationName() %></strong><br/>
                                <table class="techTable">
                                    <tr>
                                        <th width="450">Name</th>
                                        <th width="150">Value</th>
                                    </tr>
                                    <% 
                                        i = 0;
                                        for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.analysis.IMetricDescriptor, com.hello2morrow.sonargraph.core.model.analysis.IMetricValue> next : nextCategory.getValue().entrySet())
                                        {
                                            if (i % 2 == 0)
                                            {
                                                out.println("<tr class=\"a\">");
                                            }
                                            else 
                                            {
                                                out.println("<tr class=\"b\">");
                                            }
                                            i++;
                                            out.println("<td>");
                                            out.println(next.getKey().getName());
                                            out.println("</td>");
                                            out.println("<td>");
                                            if (next.getKey().getMetricId().isFloat())
                                            {
                                                out.println(String.format("%.2f", next.getValue().getValue()));
                                            }
                                            else 
                                            {
                                                out.println(next.getValue().getValue());
                                            }
                                            out.println("</td>");
                                            out.println("</tr>");
                                        }
                                    %>
                                </table>
                                <br/>
                            </td>
                        </tr>
                        <%
                        }
                        %>
                        <tr class="a">
                            <td><h2><a name="workspace"></a>Workspace <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                        </tr>
                        <%
                        if (report.getWorkspaceFilters().size() > 0)
                        {
                        %>
                        <tr>
                            <td><strong>Workspace Filter:</strong><br/>
                                <table class="techTable">
                                    <tr>
                                        <th width="150">Type</th>
                                        <th>Pattern</th>
                                        <th width="250">Info</th>
                                    </tr>
                                    <% 
                                        i = 0;
                                        for (com.hello2morrow.sonargraph.core.model.filter.WildcardPattern pattern : report.getWorkspaceFilters())
                                        {
                                            if (i % 2 == 0)
                                            {
                                                out.println("<tr class=\"a\">");
                                            }
                                            else 
                                            {
                                                out.println("<tr class=\"b\">");
                                            }
                                            out.println("<td>");
                                            out.println(pattern.getPresentationKind());
                                            out.println("</td>");
                                            
                                            out.println("<td>");
                                            out.println(pattern.getName());
                                            out.println("</td>");
                                            
                                            out.println("<td>");
                                            out.println(pattern.getInformation());
                                            out.println("</td>");
                                            
                                            out.println("</tr>");
                                            i++;
                                        } 
                                    %>
                                </table>
                                <br/>
                            </td>
                        </tr>
                        <%
                        }
                        %>
                        <tr>
                            <td><strong>Modules:</strong><br/>
                                <table class="techTable">
                                    <tr>
                                        <th width="150">Module</th>
                                        <th>Root Path</th>
                                        <th width="250">Info</th>
                                    </tr>
                                    <% 
                                        i = 0;
                                        for (com.hello2morrow.sonargraph.core.model.system.Module module : report.getModules())
                                        {
                                            int j = 0;
                                            for (com.hello2morrow.sonargraph.core.model.path.RootDirectoryPath path : module.getChildren(com.hello2morrow.sonargraph.core.model.path.RootDirectoryPath.class))
                                            {
                                                if (i % 2 == 0)
                                                {
                                                    out.println("<tr class=\"a\">");
                                                }
                                                else 
                                                {
                                                    out.println("<tr class=\"b\">");
                                                }
                                                out.println("<td>");
                                                if (j == 0)
                                                {
                                                    out.println(module.getName());
                                                }
                                                out.println("</td>");
                                                out.println("<td>");
                                                out.println(path.getName());
                                                out.println("</td>");
                                                out.println("<td>");
                                                out.println(path.getInformation());
                                                out.println("</td>");
                                                out.println("</tr>");
                                                i++;
                                                j++;
                                            }
                                        } 
                                    %>
                                </table>
                            </td>
                        </tr>
                        <tr class="a">
                            <td><h2><a name="automatedScripts"></a>Automated Scripts <% 
                            if (isScriptRunnerEnabled) 
                            { 
                                out.println("(" + report.getAutomatedScriptConfigurations().size() + ")")
                            }%> <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                        </tr>
                        <tr>
                            <td>
                                <table class="techTable" width="50%">
                                    <tr>
                                        <th width="450">Script</th>
                                        <th width="250">Run Configuration</th>
                                    </tr>
                                    <% 
                                        i = 0;
                                        for (com.hello2morrow.sonargraph.core.model.analysis.ScriptRunnerData data : report.getAutomatedScriptConfigurations())
                                        {
                                            if (i % 2 == 0)
                                            {
                                                out.println("<tr class=\"a\">");
                                            }
                                            else 
                                            {
                                                out.println("<tr class=\"b\">");
                                            }
                                            i++;
                                            out.println("<td>");
                                            out.println(data.getIdentifyingScriptPath());
                                            out.println("</td>");
                                            out.println("<td>");
                                            out.println(data.getRunConfigurationName());
                                            out.println("</td>");
                                            out.println("</tr>");
                                        }
                                        
                                        if (i == 0)
                                        {
                                            out.println("<tr class=\"a\">");
                                            if (isScriptRunnerEnabled)
                                            {
                                                out.println("<td>No automated scripts</td><td></td>");
                                            }
                                            else
                                            {
                                                out.println("<td><font color=\"red\">Script runner not licensed</font></td><td></td>");
                                            }
                                        } 
                                    %>
                                </table>
                            </td>
                        </tr>
<!-- All Unresolved Issues -->
                        <tr class="a">
                            <td><h2><a name="openIssues"></a>Unresolved Issues (<%= unresolvedIssues.size() %>) <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                        </tr>
                        <tr>
                            <td>
                                <table class="techTable" width="100%">
                                    <tr>
                                        <th width="100">Type</th>
                                        <th width="350">Description</th>
                                        <th width="70">Severity</th>
                                        <th width="80">Category</th>
                                        <th width="350">Element</th>
                                        <th width="350">To Element</th>
                                        <th width="100">Provider</th>
                                    </tr>
                                    <%
                                    i = 0;
                                    for (com.hello2morrow.sonargraph.core.model.element.Issue issue : report.getUnresolvedIssues())
                                    {
                                        if (i % 2 == 0)
                                        {
                                            out.println("<tr class=\"a\">");
                                        }
                                        else 
                                        {
                                            out.println("<tr class=\"b\">");
                                        }
                                        out.println("<td>");
                                        out.println(issue.getName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(issue.getDescription());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(issue.getId().getSeverity().getPresentationName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(issue.getId().getCategory().getPresentationName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(report.getElementOrFrom(issue));
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(report.getTo(issue));
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(issue.getProvider().getPresentationName());
                                        out.println("</td>");
                                        out.println("</tr>");
                                        i++;
                                    }
                                    if (i == 0)
                                    {
                                        out.println("<tr class=\"a\">");
                                        out.println("<td>No open issues</td><td></td><td></td><td></td><td></td><td></td><td></td>");
                                    }  
                                    %>
                                </table>
                            </td>
                        </tr>
<!-- Unresolved Cycle Groups -->
                        <tr class="a">
                            <td><h2><a name="cycleGroups"></a>Unresolved Cycle Groups (<%= report.getNumberOfUnresolvedCycleGroups() %>) <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                        </tr>
                        <tr>
                            <td>
                                <% 
                                for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.analysis.IAnalyzerId, java.util.List<com.hello2morrow.sonargraph.core.model.analysis.CycleGroupIssue>> entry : report.getUnresolvedCycleIssues().entrySet())
                                {
                                    i = 0;
                                %>
                                <h3><%= entry.getKey().getPresentationName() %> (<%= entry.getValue().size() %>) <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h3>
                                <table class="techTable" width="80%">
                                    <tr>
                                        <th width="100">Name</th>
                                        <th width="80">Scope</th>
                                        <th width="50">Size</th>
                                        <th width="250">Involved Elements</th>
                                    </tr>
                                    <%
                                    for (com.hello2morrow.sonargraph.core.model.analysis.CycleGroupIssue nextCycleGroupIssue : entry.getValue())
                                    {
                                        int j = 0;
                                        com.hello2morrow.sonargraph.core.model.analysis.AnalyzerCycleGroup group = ((com.hello2morrow.sonargraph.core.model.analysis.AnalyzerCycleGroup) nextCycleGroupIssue.getAffectedElement())

                                        for (com.hello2morrow.sonargraph.core.model.element.NamedElement next : group.getCyclicNamedElements())
                                        {
                                            if (i % 2 == 0)
                                            {
                                                out.println("<tr class=\"a\">");
                                            }
                                            else 
                                            {
                                                out.println("<tr class=\"b\">");
                                            }
                                            out.println("<td>");
                                            if (j == 0)
                                            {
                                                out.println(nextCycleGroupIssue.getAffectedElement().getName());
                                            }
                                            out.println("</td>");
                                            out.println("<td>");
                                            if (j == 0)
                                            {
                                                out.println(group.getScope().getImageResourceName() + ": " + group.getScope().getPresentationName(true));
                                            }
                                            out.println("</td>");
                                            out.println("<td>");
                                            if (j == 0)
                                            {
                                                out.println(group.getNumberOfCyclicElements());
                                            }
                                            out.println("</td>");
                                            out.println("<td>");
                                            out.println(next.getPresentationName(false));
                                            out.println("</td>");
                                            out.println("</tr>");
                                            j++;
                                            i++;
                                        }    
                                    }
                                    %>
                                </table>
                                    <%
                                    if (entry.getValue().size() == 0)
                                    {
                                       out.println("No " + entry.getKey().getPresentationName() + "<br/>");
                                    }
                                    %>
                                <%
                                }
                                if (i == 0)
                                {
                                    out.println("<br/>No cycle groups detected<br/>");
                                } 
                                %>
                            </td>
                        </tr>
<!-- Unresolved Duplicate Blocks -->                        
                        <tr class="a">
                            <td><h2><a name="duplicateBlocks"></a>Unresolved Duplicate Blocks <% 
                            if (isDuplicateCodeEnabled) 
                            { 
                                out.println("(" + report.getUnresolvedDuplicateIssues().size() + ")")
                            }%> <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                        </tr>
                        <tr>
                            <td>
                                <table class="techTable" width="80%">
                                    <tr>
                                        <th width="80">Name</th>
                                        <th width="250">File</th>
                                        <th width="50">Line Range</th>
                                        <th width="50">Block Length (Lines)</th>
                                        <th width="50">Tolerance (Lines)</th>
                                    </tr>
                                    <% 
                                    
                                    i = 0;
                                    for (com.hello2morrow.sonargraph.core.model.analysis.DuplicateCodeBlockIssue duplicateIssue : report.getUnresolvedDuplicateIssues())
                                    {
                                        com.hello2morrow.sonargraph.core.model.analysis.DuplicateCodeBlock duplicate = (com.hello2morrow.sonargraph.core.model.analysis.DuplicateCodeBlock) duplicateIssue.getAffectedElement();
                                        if (i % 2 == 0)
                                        {
                                            out.println("<tr class=\"a\">");
                                        }
                                        else 
                                        {
                                            out.println("<tr class=\"b\">");
                                        }
                                        out.println("<td>");
                                        out.println(duplicate.getName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(duplicate.getBlockSize());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println("</td>");
                                        out.println("</tr>");
                                        
                                        i++;
                                        j = 0;
                                        for (com.hello2morrow.sonargraph.core.model.analysis.DuplicateCodeBlockOccurrence occurrence : duplicate.getChildren(com.hello2morrow.sonargraph.core.model.analysis.DuplicateCodeBlockOccurrence.class))
                                        {
                                            if (i % 2 == 0)
                                            {
                                                out.println("<tr class=\"a\">");
                                            }
                                            else 
                                            {
                                                out.println("<tr class=\"b\">");
                                            }
                                            out.println("<td>");
                                            out.println("</td>");
                                            out.println("<td>");
                                            out.println(occurrence.getSourceFile().getPresentationName(false));
                                            out.println("</td>");
                                            out.println("<td>");
                                            out.println(occurrence.getLineRange());
                                            out.println("</td>");
                                            out.println("<td>");
                                            out.println(occurrence.getBlockSize());
                                            out.println("</td>");
                                            out.println("<td>");
                                            out.println(occurrence.getToleranceAsInt());
                                            out.println("</td>");
                                            out.println("</tr>");
                                            j++;
                                            i++;
                                        }
                                    }
                                    if (i == 0)
                                    {
                                        out.println("<tr class=\"a\">");
                                        if (isDuplicateCodeEnabled)
                                        {
                                            out.println("<td>No duplicate blocks</td><td></td><td></td><td></td><td></td>");
                                        }
                                        else
                                        {
                                            out.println("<td><font color=\"red\">Duplicate code not licensed</font></td><td></td><td></td><td></td><td></td>");
                                        }
                                    } 
                                    %>
                                </table>
                            </td>
                        </tr>
<!-- Resolutions -->    
                  <%  
                  if (!isVirtualModelsEnabled) 
                  { 
                  %>   
                    <tr class="a">
                        <td><h2><a name="resolutions"></a>Resolutions  <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                    </tr>
                    <%
                    } 
                    else
                    {
                    %>
                    <tr class="a">
                        <td><h2><a name="resolutions"></a>Resolutions (<%= resolutions.size() %>) of Virtual Model "<%= report.currentVirtualModel %>" <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                    </tr>
                    <%
                    }
                    %>                                    
                        <tr>
                            <td>
                                <table class="techTable" width="100%">
                                    <tr>
                                        <th width="80">Resolution Type</th>
                                        <th width="120">Issue Type</th>
                                        <th width="250">Description</th>
                                        <th width="250">Information</th>
                                        <th width="70">Date</th>
                                        <th width="70">Matched</th>
                                        <th width="70">Priority</th>
                                        <th width="70">Assignee</th>
                                        <!-- th width="80">Issues</th -->
                                    </tr>
                                    <% 
                                    i = 0;
                                    for (com.hello2morrow.sonargraph.core.model.element.Resolution resolution : report.getResolutions())
                                    {
                                        if (i % 2 == 0)
                                        {
                                            out.println("<tr class=\"a\">");
                                        }
                                        else 
                                        {
                                            out.println("<tr class=\"b\">");
                                        }
                                        i++;
                                        out.println("<td>");
                                        out.println(resolution.getPresentationKind());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(report.getIssueType(resolution));
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(resolution.getDescription());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(resolution.getInformation());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(report.getDate(resolution.getDate()));
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(resolution.getMatchingElementsCount());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(resolution.getPriority().getPresentationName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(resolution.getAssignee());
                                        out.println("</td>");
/*                                      out.println("<td>");
                                        for (final com.hello2morrow.sonargraph.core.model.element.IIssueAccessor issueAccessor : resolution.getAssociatedIssues())
                                        {
                                            final com.hello2morrow.sonargraph.core.model.element.Issue issue = (com.hello2morrow.sonargraph.core.model.element.Issue) issueAccessor;
                                            out.println(issue.getName());
                                            out.println("<br/>");
                                        }
                                        out.println("</td>");
*/                                      out.println("</tr>");
                                    }
                                    if (!isVirtualModelsEnabled)
                                    {
                                        out.println("<tr class=\"a\">");
                                        out.println("<td><font color=\"red\">Virtual models not licensed</font></td><td></td><td></td><td></td><td></td><td></td><td></td><td></td>");
                                        out.println("</tr>");
                                    }
                                    else if (i == 0)
                                    {
                                        out.println("<tr class=\"a\">");
                                        out.println("<td>No resolutions</td><td></td><td></td><td></td><td></td><td></td><td></td><td></td>");
                                        out.println("</tr>");
                                    } 
                                    %>
                                </table>
                            </td>
                        </tr>              
<!-- Element Metrics -->                                        
                        <tr class="a">
                            <td><h2><a name="elementMetrics"></a>Element Level Metrics <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                        </tr>
                        <% for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.analysis.IMetricLevel, java.util.Map<
                               com.hello2morrow.sonargraph.core.model.analysis.IMetricCategory, 
                                java.util.Map<com.hello2morrow.sonargraph.core.model.analysis.IMetricDescriptor, 
                                java.util.Set<com.hello2morrow.sonargraph.core.model.report.Report.MetricRow>>>> entry : metricValueRows.entrySet())
                        {
                        %>
                            <tr class="a">
                                <td>
                                    <h3><a name="elementMetrics_<%=entry.getKey().getStandardName()%>"></a><%=entry.getKey().getPresentationName()%> Level Metrics <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h3>
                                </td>
                            </tr>
                            <% for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.analysis.IMetricCategory, 
                                java.util.Map<com.hello2morrow.sonargraph.core.model.analysis.IMetricDescriptor, 
                                java.util.Set<com.hello2morrow.sonargraph.core.model.report.Report.MetricRow>>> nextCategory : entry.getValue().entrySet())
                               {
                            %>
                            <tr>
                                <td>        
                                    <strong>Metric Category: <%= nextCategory.getKey().getPresentationName()%></strong><br/>
                                    <table class="techTable">
                                        <tr>
                                            <th width="150">Metric</th>
                                            <th><%=entry.getKey().getPresentationName()%></th>
                                            <th width="50">Value</th>
                                        </tr>
                                        <%
                                        i = 0;
                                        String currentMetric = null;
                                        for (java.util.Map.Entry<com.hello2morrow.sonargraph.core.model.analysis.IMetricDescriptor, java.util.Set<com.hello2morrow.sonargraph.core.model.report.Report.MetricRow>> rowMap : nextCategory.getValue().entrySet())
                                        {
                                            for (com.hello2morrow.sonargraph.core.model.report.Report.MetricRow row : rowMap.getValue())
                                            {  
                                                if (i % 2 == 0)
                                                {
                                                    out.println("<tr class=\"a\">");
                                                }
                                                else 
                                                {
                                                    out.println("<tr class=\"b\">");
                                                }
                                                out.println("<td>");
                                                if (!row.getMetricName().equals(currentMetric))
                                                {
                                                    out.println(row.getMetricName());
                                                }
                                                out.println("</td>");
                                                out.println("<td>");
                                                out.println(row.getElementName());
                                                out.println("</td>");
                                                out.println("<td>");
                                                if (row.isFloat())
                                                {
                                                    out.println(String.format("%.2f", row.getMetricValue()));
                                                }
                                                else 
                                                {
                                                    out.println(row.getMetricValue());
                                                }
                                                out.println("</td>");
                                                out.println("</tr>");
                                                i++;
                                                currentMetric = row.getMetricName();
                                            }
                                        } 
                                        %>
                                    </table>
                                    <br/>
                                </td>
                            </tr>
                        <%
                            }
                        }
                        %>
<!-- Metric Information -->     
                        <tr class="a">
                            <td><h2><a name="metricInfos"></a>Metric Info <a href="#top"><font size="1" color="#9999ff">[Top]</font></a></h2></td>
                        </tr>
                        <tr>
                            <td>
                                <table class="techTable" width="100%">
                                    <tr>
                                        <th width="180">Name</th>
                                        <th>Description</th>
                                        <th width="180">Category</th>
                                        <th width="150">Provider</th>
                                    </tr>
                                    <%
                                    i = 0;
                                    for (com.hello2morrow.sonargraph.core.model.analysis.IMetricId metric : report.getMetricIds())
                                    {
                                        if (i % 2 == 0)
                                        {
                                            out.println("<tr class=\"a\">");
                                        }
                                        else 
                                        {
                                            out.println("<tr class=\"b\">");
                                        }
                                        out.println("<td>");
                                        out.println(metric.getPresentationName());
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(metric.getDescription());
                                        out.println("</td>");
                                        out.println("<td>");
                                        java.util.List<String> categories = new java.util.ArrayList<String>();
                                        for (com.hello2morrow.sonargraph.core.model.analysis.IMetricCategory next : metric.getCategories())
                                        {
                                            categories.add(next.getPresentationName());
                                        }
                                        out.println(com.hello2morrow.foundation.utilities.StringUtility.concat(categories, ", "));
                                        out.println("</td>");
                                        out.println("<td>");
                                        out.println(metric.getProvider().getPresentationName());
                                        out.println("</td>");
                                        out.println("</tr>");
                                        i++;
                                    } 
                                    %>
                                </table>
                            </td>
                        </tr>                                                                                                                        
                    </table>
                </td>
                
    <!-- end of real content -->
            </tr>
        </table>
    </body>
</html>